;***************************************************************
;			  SOUND FX TEST
;			      BY
;		MARKUS KLISICS - MARKEY (TCPA)
;
;	       HOMEPAGE: WWW.MARKUSOFT.COM
;		  EMAIL: MARKLI-9@STUDENT.LUTH.SE
;***************************************************************

	include	"D:\Programmering\Ti92plus\DoorsOS\Include\doorsos.h"
	include fxlib.h

	xdef	_main
	xdef	_comment
	xdef	_ti89

GetKey		MACRO
	move.w		\1,($600018)
	nop
	nop
	nop
	nop
	nop
	nop
	move.b		($60001B),d7
		ENDM


;***************************************************************

_main:
	jsr		fxlib::install		; Install interrupt

	jsr		_ROM_CALL_19e		; Clear Screen

	bsr		doStuff

	jsr		fxlib::uninstall	; Uninstall interrupt
	rts					; Exit

doStuff:
	move.w		#80,d0			; X-coord
	move.w		#50,d1			; Y-coord
	move.w		#1,d2			; Dir x
	move.w		#1,d3			; Dir y
doloop:
	lea		ball(PC),a0
	bsr		PutSprite

	move.w		#300,-(a7)
	jsr		fxlib::delay
	lea		2(a7),a7

	lea		empty(PC),a0
	bsr		PutSprite

	cmp.w		#140,d0
	blt		test_hl
	move.w		#-1,d2
	move.w		#_ONCE,-(a7)
	pea		fx1(PC)
	jsr		fxlib::playfx
	lea		6(a7),a7
test_hl:
	cmp.w		#2,d0
	bgt		test_vh
	move.w		#1,d2
	move.w		#_ONCE,-(a7)
	pea		fx2(PC)
	jsr		fxlib::playfx
	lea		6(a7),a7
test_vh:
	cmp.w		#80,d1
	blt		test_vl
	move.w		#-1,d3
	move.w		#_ONCE,-(a7)
	pea		fx3(PC)
	jsr		fxlib::playfx
	lea		6(a7),a7
test_vl:
	cmp.w		#2,d1
	bgt		test_done
	move.w		#1,d3
	move.w		#_ONCE,-(a7)
	pea		fx4(PC)
	jsr		fxlib::playfx
	lea		6(a7),a7

test_done:
	add.w		d2,d0
	add.w		d3,d1

	GetKey		#$FFBF			; [ESC]?
	btst.b		#0,d7
	bne		doloop

	rts


PutSprite:
	movem.l		d0-d3/a0-a1,-(a7)
	lsl.w		#1,d1
	move.l		d1,d3
	lsl.w		#4,d3
	sub.w		d1,d3
	move.b		d0,d1
	and.w		#$FFF0,d0
	lsr.b		#3,d0
	add.w		d0,d3
	and.b		#$0F,d1
	sub.b		#16,d1
	neg		d1
	move.l		#LCD_MEM,a1
	adda.l		d3,a1
	move.l		#$FFFF0000,d3
	rol.l		d1,d3
	move.l		#15,d2
ps16loop:
	clr.l		d0
	move.w		(a0)+,d0
	lsl.l		d1,d0
	and.l		d3,(a1)
	or.l		d0,(a1)
	lea		30(a1),a1
	dbra		d2,ps16loop
	movem.l		(a7)+,d0-d3/a0-a1
	rts


;***************************************************************

ball:		dc.w	%0000011111100000
		dc.w	%0001111111111000
		dc.w	%0011111111111100
		dc.w	%0111001111001110
		dc.w	%0110110110110110
		dc.w	%1110110110110111
		dc.w	%1110110110110111
		dc.w	%1111001111001111
		dc.w	%1111111111111111
		dc.w	%1111111111111111
		dc.w	%1111111111111111
		dc.w	%0110111111110110
		dc.w	%0111001111001110
		dc.w	%0011110000111100
		dc.w	%0001111111111000
		dc.w	%0000011111100000

empty:		ds.w	16

fx1:		dc.w	18,300
		dc.w	14,300
		dc.w	10,300
		dc.w	14,300
		dc.w	10,300
		dc.w	6,300
		dc.w	10,300
		dc.w	6,300
		dc.w	2,300
		dc.w	_END

fx2:		dc.w	10,200
		dc.w	8,200
		dc.w	16,200
		dc.w	10,200
		dc.w	8,200
		dc.w	16,200
		dc.w	10,200
		dc.w	8,200
		dc.w	16,200
		dc.w	10,200
		dc.w	8,200
		dc.w	16,200
		dc.w	_END

fx3:		dc.w	4,150
		dc.w	5,150
		dc.w	6,150
		dc.w	7,150
		dc.w	8,150
		dc.w	9,150
		dc.w	10,150
		dc.w	11,150
		dc.w	12,150
		dc.w	13,150
		dc.w	14,150
		dc.w	15,150
		dc.w	_END

fx4:		dc.w	24,400
		dc.w	18,400
		dc.w	12,400
		dc.w	20,400
		dc.w	14,400
		dc.w	8,400
		dc.w	16,400
		dc.w	10,400
		dc.w	4,400
		dc.w	_END


_comment	dc.b	"Sound FX Test",0

;***************************************************************

	end